Bugzilla (bugzilla.redhat.com) will be under maintenance for infrastructure upgrades and will not be unavailable on July 31st between 12:30 AM - 05:30 AM UTC. We appreciate your understanding and patience. You can follow status.redhat.com for details.
Bug 1271192 - Incorrect handling of ERESTARTSYS could cause soft lockups
Summary: Incorrect handling of ERESTARTSYS could cause soft lockups
Keywords:
Status: CLOSED EOL
Alias: None
Product: Fedora
Classification: Fedora
Component: xorg-x11-drv-qxl
Version: 22
Hardware: Unspecified
OS: Unspecified
unspecified
unspecified
Target Milestone: ---
Assignee: Frediano Ziglio
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2015-10-13 11:04 UTC by Frediano Ziglio
Modified: 2016-07-19 18:12 UTC (History)
8 users (show)

Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Clone Of:
Environment:
Last Closed: 2016-07-19 18:12:14 UTC
Type: Bug


Attachments (Terms of Use)

Description Frediano Ziglio 2015-10-13 11:04:43 UTC
Description of problem:

Initial problem was reported about handling additional surfaces using QXL kernel driver and easy reproducible with KDE plasma.
I don't remember if I was reproducing with RHEL6/RHEL7 or Fedora 22 (surely I was using this as host).

I lost the reproduction environment and original bug.

Mainly I'm opening this bug to keep track of the issue.

The issue could happen even not using surfaces (but is much less probable). The problem is that when a signal is send to the program (which is likely to happen with X which receives a lot of SIGURG signals) the kernel driver goes into a tight loop on ERESTARTSYS. As Dave Airlie pointed out (https://lkml.org/lkml/2015/5/27/1038) this loop inside the kernel is done as QXL driver is not able to handle restarting the call correctly. However removing wait_for_io_cmd as suggested looks like can make the driver lose some command if sent too fast.

Would be good to have a PoC to make easier to reproduce this (even on primary surface creation and screen updates that is without surfaces) and fix the main issue.


Version-Release number of selected component (if applicable):


How reproducible:

Enable surfaces (need to enable also in the driver).
Installe KDE plasma. Play with it for a while till you will see hangs and CPU usage going very high.


Steps to Reproduce:
1. patch driver to enable surfaces
2. install KDE plasma
3. play with interface


Actual results:

Hangs and slow downs


Expected results:

No hangs


Additional info:

See https://lkml.org/lkml/2015/5/27/1038 for proposed patch.

Comment 1 Frediano Ziglio 2015-10-13 11:05:42 UTC
Related issue is https://bugzilla.redhat.com/show_bug.cgi?id=1027831.

Comment 2 Fedora End Of Life 2016-07-19 18:12:14 UTC
Fedora 22 changed to end-of-life (EOL) status on 2016-07-19. Fedora 22 is
no longer maintained, which means that it will not receive any further
security or bug fix updates. As a result we are closing this bug.

If you can reproduce this bug against a currently maintained version of
Fedora please feel free to reopen this bug against that version. If you
are unable to reopen this bug, please file a new report against the
current release. If you experience problems, please add a comment to this
bug.

Thank you for reporting this bug and we are sorry it could not be fixed.


Note You need to log in before you can comment on or make changes to this bug.